%% Reset
clear all; close all; clc
tic
%% Import
import org.opensim.modeling.*;
%% Open a Model by name
foot1 = Model('C:\Users\shayan\Desktop\model-20170712T165116Z-001/foot1.osim');
%% Compute the force and torque at the specified time
s = foot1.initSystem();
manager = Manager(foot1);
%% set start and end time
i=1;
timeInterval=0.01;
manager.setInitialTime(0);
for t=timeInterval:timeInterval:1;
manager.setFinalTime(t);
% integrate
manager.integrate(s);
velocity{i,1}=foot1.calcMassCenterVelocity(s);
    if (t >= 0.1) % this is totally inaccurate and only makes sure the monitoring happens after t=0
        if abs(abs(velocity{i,1}.get(0))-abs(velocity{i-1,1}.get(0)))<1e-8
        settletime=s.getTime()
        break
        end
    end
i=i+1;
end
%% simulation with force
period1 = settletime:timeInterval:0.5;
period2 = 0.5:timeInterval:1;
period3=1:timeInterval:2;
force1 = zeros(1,length(period1));
force2 = abs(cos(period2+pi));
% vpa(subs(force2,period2,0.1)) % need to define the derivative function
increaseRate=abs(-sin(period2(end)+pi));
force3 = abs(cos(0.1+pi))+increaseRate*period3;
forcetime=[period1 period2 period3];
forcevalue=[force1 force2 force3];
matrix=[forcetime;forcevalue];
%% appending force
body  = foot1.getBodySet().get('foot');
force = PrescribedForce(body);
forceX = SimmSpline();
forceY = SimmSpline();
forceZ = SimmSpline();
for j=1 : length(forcevalue) % should be better handled
    forceX.addPoint(matrix(1,j),matrix(2,j));
    forceY.addPoint(matrix(1,j),matrix(2,j));
    forceZ.addPoint(matrix(1,j),matrix(2,j));
end
%% Adding the force to the model
force.setForceFunctions(forceX, forceY, forceZ);
force.setPointFunctions(Constant(0), Constant(0), Constant(-0.1)); % By default the point is specified in the body's local coordinates.
%% Append the forces
foot1.updForceSet().append(force);
s2 = foot1.initSystem();
manager = Manager(foot1);
manager.setInitialTime(settletime);
foot1.print('C:\Users\shayan\Desktop\model-20170712T165116Z-001/model.osim');
p=1;
for t=settletime+timeInterval:timeInterval:2;
manager.setFinalTime(t);
% integrate
manager.integrate(s2);
velocity1{p,1}=foot1.calcMassCenterVelocity(s2);
    if (t >= 0.2 && p>=2) 
        if abs(abs(velocity1{p,1}.get(0))-abs(velocity1{p-1,1}.get(0)))>1e-7
        sliptime=s2.getTime()
        force=body.PrescribedForce.getForceAtTime(sliptime)
        break
        end
    end
p=p+1;
end
toc